//
//  created by S.Tomabechi 1993,1995
//
//  calculate mathematical constants
//
//  ĤŵŪʴ׻
//
//  Knuth The Art of Computer Programming
//         Seminumerical algorithms
//
//   3.2.36 ˤ
//
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>
#ifdef WIN32 
#include <strstrea.h>
#else 
#include <strstream.h>
#endif
#include "Fint.hpp"
#include "FintFunc.hpp"

int main(void)
{
  SetFormat(noSpace) ;
  short precision ;


  for(;;) {
    cout << endl << "Input precision (Input 0 to exit)  " ;
    cin >> precision ;
    if( precision<=0 ) break ;
    precision=double(precision)/(4*2.40824)+1 ;

    SetPrecision(precision) ;        // ʲη

               // Ѵʤ sqrt(double) Ȳᤵ
    cout << endl << "sqrt(2)  " << sqrt(Fint(2)) ;

    cout << endl << "sqrt(3)  " << sqrt(Fint(3)) ;

    cout << endl << "sqrt(5)  " << sqrt(Fint(5)) ;

    cout << endl << "sqrt(10)  " << sqrt(Fint(10)) ;

    cout << endl << "cubrt(2) " << cubrt(Fint(2)) ;

    cout << endl << "cubrt(3) " << cubrt(Fint(3)) ;

    cout << endl << "sqrt(sqrt(2)) " <<  sqrt(sqrt(Fint(2))) ;

    cout << endl << "log(2) " << log(Fint(2)) ;

    cout << endl << "log(3) " << log(Fint(3)) ;

    cout << endl << "log(10) " << log(Fint(10)) ;

    cout << endl << "1/log(2) " << 1/log(Fint(2)) ;

    cout << endl << "1/log(10) " << 1/log(Fint(10)) ;

    cout << endl << " " << pi()  ;

    cout << endl << "/180 " << pi()/180 ;

    cout << endl << "1/ " << 1/pi() ;

    cout << endl << "* " << pi()*pi() ;

    cout << endl << "sqrt() " << sqrt(pi()) ;

//continue ;
    Fint a ;

    (a=1) /= 2 ;               // a=1/2
    cout << endl << "(1/2) " << gamma(a) ;

    (a=1) /= 3 ;
    cout << endl << "(1/3) " << gamma(a) ;

    (a=2) /= 3  ;
    cout << endl << "(2/3) " << gamma(a) ;

    cout << endl << "e " << exp(Fint(1)) ;

    cout << endl << "1/e " << 1/exp(Fint(1)) ;

    cout << endl << "e*e " << exp(Fint(1))*exp(Fint(1)) ;

    Fint gam=Euler() ;
    cout << endl << "Euler's constant  " << gam ;


    cout << endl << "log() " << log(pi()) ;

    Fint phi=(1+sqrt(Fint(5)))/2 ;
    cout << endl << "=(1+sqrt(2))/2 : " << phi ;

    cout << endl << "exp() " << exp(gam) ;

    cout << endl << "exp(/4) " << exp(pi()/4) ;

    cout << endl << "sin(1) " << sin(Fint(1)) ;

    cout << endl << "cos(1) " << cos(Fint(1)) ;

    cout << endl << "-'(2)  " << -dzeta2() ;

    cout << endl << " (3) " << zeta3() ;

    cout << endl << "log() " << log(phi) ;

    cout << endl << "1/log() " << 1/log(phi) ;

    cout << endl << "-log(log(2)) " << -log(log(Fint(2))) ;
  }
  return 0 ;
}
