CC = g++ 		   
NASM = nasm	
#NASM=nasmw 
TLIB = tlib
AR = ar 
ARFLAGS = rcs
#TLINK = g++ -Wl,-Map mintlib.map
TLINK = g++  -Wl,-Map ppsiqs.map
AFLAGS = -f elf	-i../include/   #  for Linux
#AFLAGS = -f coff -i../include/   #  for Linux
CFLAGS = -c -I../include		
#CFLAGS = -S -g  -I../include
#CFLAGS = -c	
LFLAGS  = -L../lib -lmint
SIQS = 1 
.c.o:
	  $(CC) {$< }

.cpp.o:
	  $(CC) -c {$< }
.asm.o:
	  $(NASM) $(AFLAGS)	 {$< }

OBJS =siqs_bl.o\
	 bdecomp_new.o\
	siqs_divbase_new.o\
	siqs_shift.o\
	siqs_table.o\
	siqs_sieve_done.o\
	siqs_sieve_new.o\
	siqs_sieve_init.o\
	ppmpqs_work.o\


#		*Explicit Rules*
ppsiqs: $(OBJS) 
	$(TLINK) -o $@ $(OBJS) $(LFLAGS)  
	
bdecomp_new.o:bdecomp_new.asm 
	$(NASM) $(AFLAGS) bdecomp_new.asm 

siqs_divbase_new.o:siqs_divbase_new.asm
	$(NASM) $(AFLAGS) siqs_divbase_new.asm

siqs_shift.o:siqs_shift.asm 
	$(NASM) $(AFLAGS) siqs_shift.asm 

siqs_table.o:siqs_table.asm
	$(NASM) $(AFLAGS) siqs_table.asm

siqs_sieve_done.o:siqs_sieve_done.asm 
	$(NASM) $(AFLAGS) siqs_sieve_done.asm

siqs_sieve_new.o:siqs_sieve_new.asm
	$(NASM) $(AFLAGS) siqs_sieve_new.asm 

siqs_sieve_init.o:siqs_sieve_init.asm
	$(NASM) $(AFLAGS) siqs_sieve_init.asm 

siqs_bl.o:siqs_bl.cpp
	$(CC)	$(CFLAGS) siqs_bl.cpp

ppmpqs_work.o:ppmpqs_work.cpp
	$(CC) $(CFLAGS) ppmpqs_work.cpp

