%include "mint.inc"
[BITS 32]
	extrn	@$bdla$qpv
	extrn	@Mint@$basg$qxl
	extrn	@Mint@isDivUL$qrx4Mintxul
	extrn	@Mint@isShiftl$qrx4Mintxl
	extrn	@Mint@allocate$qi
	extrn	@Mint@Precision
	extrn	@Mint@FFT_digit
	extrn	@Mint@_uMtemp
	extrn	@Mint@_vMtemp
	extrn	@Fint@$basg$qrx4Mint
	extrn	@Fint@isMulF$qrx4Mintt1
	public	@Fint@isDivF$qrx4Mintt1
	extrn	@Fint@isInverse$qrx4Fint
	extrn	@inverse$qrx4Mint
	extrn	___assertfail
[SECTION .text]	
@Fint@isDivF$qrx4Mintt1
   ;	
   ;	Fint& Fint::isDivF(const Mint& a,const Mint& b)
   ;	
	push      ebp
	mov       ebp,esp
	add       esp,-100
	push      ebx
	push      esi
	push      edi
   ;	
   ;	{
   ;	#ifdef _MEMMAN_DEBUG
   ;	a.check(__FILE__,__LINE__) ;
   ;	b.check(__FILE__,__LINE__) ;
   ;	#endif
   ;	  int anDigit ;
   ;	  int afDigit ;
   ;	  int bnDigit ;
   ;	  int bfDigit ;
   ;	
   ;	  __asm {
   ;		mov esi,a
   ;	
@1:
	mov	 esi,dword ptr [ebp+12]
   ;	
   ;	#ifdef __BORLANDC__
   ;		mov eax,[esi.nDigit]
   ;	
	mov	 eax,[esi+4]
   ;	
   ;		mov ebx,[esi.fDigit]
   ;	
	mov	 ebx,[esi+8]
   ;	
   ;	#else
   ;		mov eax,[esi+NDIGIT]
   ;		mov ebx,[esi+FDIGIT]
   ;	#endif
   ;		or	eax,eax
   ;	
	or		eax,eax
   ;	
   ;		jz	SetZero			// a is zero
   ;	
	jz        @2
   ;	
   ;		mov anDigit,eax
   ;	
	mov	 dword ptr [ebp-4],eax
   ;	
   ;		mov afDigit,ebx
   ;	
	mov	 dword ptr [ebp-8],ebx
   ;	
   ;	
   ;		mov esi,b
   ;	
	mov	 esi,dword ptr [ebp+16]
   ;	
   ;	#ifdef __BORLANDC__
   ;		mov eax,[esi.nDigit]
   ;	
	mov	 eax,[esi+4]
   ;	
   ;		mov ebx,[esi.fDigit]
   ;	
	mov	 ebx,[esi+8]
   ;	
   ;	#else
   ;		mov eax,[esi+NDIGIT]
   ;		mov ebx,[esi+FDIGIT]
   ;	#endif
   ;		or	eax,eax						   // b is zero
   ;	
	or		eax,eax						   
   ;	
   ;		jz	ZeroDivide
   ;	
	jz        short @3
   ;	
   ;		mov bnDigit,eax
   ;	
	mov	 dword ptr [ebp-12],eax
   ;	
   ;		mov bfDigit,ebx
   ;	
	mov	 dword ptr [ebp-16],ebx
   ;	
   ;		jmp BigNumber
   ;	
	jmp       short @4
   ;	
   ;	  }
   ;	
   ;	SetZero:
   ;	  return *this=a ;
   ;	
@2:
	push      dword ptr [ebp+12]
	push      dword ptr [ebp+8]
	call      @Fint@$basg$qrx4Mint
	add       esp,8
	jmp       @5
   ;	
   ;	
   ;	ZeroDivide:
   ;	  Error(zero divide) ;
   ;	
@3:
	push      dword 61
	push      dword offset s@+50
	push      dword offset s@+38
	push      dword offset s@
	call      ___assertfail
	add       esp,16
   ;	
   ;	
   ;		 // too big number
   ;	BigNumber:
   ;	  if( bnDigit>FFT_digit && afDigit>0 ) {
   ;	
@4:
	mov       eax,dword ptr [ebp-12]
	cmp       eax,dword ptr [@Mint@FFT_digit]
	jle       short @8
	cmp       dword ptr [ebp-8],0
	jle       short @8
   ;	
   ;		if( b.fDigit!=0 ) return isMulF(a,(Mint&)(isInverse((Fint&)b))) ;
   ;	
@7:
@6:
	mov       edx,dword ptr [ebp+16]
	cmp       dword ptr [edx+8],0
	je        short @9
	push      dword ptr [ebp+16]
	push      dword ptr [ebp+8]
	call      @Fint@isInverse$qrx4Fint
	add       esp,8
	push      eax
	push      dword ptr [ebp+12]
	push      dword ptr [ebp+8]
	call      @Fint@isMulF$qrx4Mintt1
	add       esp,12
	jmp       @5
   ;	
   ;		else return isMulF(a,inverse(b)) ;
   ;	
@9:
	push      dword ptr [ebp+16]
	lea       ecx,[ebp-100]
	push      ecx
	call      @inverse$qrx4Mint
	add       esp,8
	lea       eax,[ebp-100]
	push      eax
	push      dword ptr [ebp+12]
	push      dword ptr [ebp+8]
	call      @Fint@isMulF$qrx4Mintt1
	add       esp,12
	push      eax
	push      dword ptr [ebp-100]
	call      @$bdla$qpv
	pop       ecx
	pop       eax
	jmp       @5
   ;	
   ;	  }
   ;	
   ;	
   ;	  int ufDigit ;
   ;	  int shift ;
   ;								  // decide fractional point of the result
   ;								  // ֤
   ;	  if( afDigit>=bfDigit ) {
   ;	
@10:
@8:
	mov       edx,dword ptr [ebp-8]
	cmp       edx,dword ptr [ebp-16]
	jl        short @11
   ;	
   ;		if( afDigit!=0 ) {
   ;	
	cmp       dword ptr [ebp-8],0
	je        short @12
   ;	
   ;		  ufDigit=afDigit ;
   ;	
	mov       ecx,dword ptr [ebp-8]
	mov       dword ptr [ebp-20],ecx
   ;	
   ;		  shift=bfDigit ;
   ;	
	mov       eax,dword ptr [ebp-16]
	mov       dword ptr [ebp-24],eax
   ;	
   ;		}
   ;	
	jmp       short @13
   ;	
   ;		else ufDigit=shift=GetPrecision() ;
   ;	
@12:
	mov       edx,dword ptr [@Mint@Precision]
	mov       dword ptr [ebp-24],edx
	mov       dword ptr [ebp-20],edx
   ;	
   ;	  // Ȥ
   ;	  // shift ʬ䤷Ʒ׻
   ;	  }
   ;	
	jmp       short @13
   ;	
   ;	  else {
   ;		if( afDigit!=0 ) {
   ;	
@11:
	cmp       dword ptr [ebp-8],0
	je        short @14
   ;	
   ;		  shift=bfDigit+(bfDigit-afDigit) ;
   ;	
	mov       eax,dword ptr [ebp-16]
	sub       eax,dword ptr [ebp-8]
	add       eax,dword ptr [ebp-16]
	mov       dword ptr [ebp-24],eax
   ;	
   ;		  ufDigit=bfDigit ;		  // b ȷ碌 bξե
   ;	
	mov       ecx,dword ptr [ebp-16]
	mov       dword ptr [ebp-20],ecx
   ;	
   ;		}
   ;	
	jmp       short @15
   ;	
   ;		else {					  // a 
   ;		  shift=2*bfDigit ;
   ;	
@14:
	mov       eax,dword ptr [ebp-16]
	add       eax,eax
	mov       dword ptr [ebp-24],eax
   ;	
   ;		  ufDigit=bfDigit ;
   ;	
	mov       edx,dword ptr [ebp-16]
	mov       dword ptr [ebp-20],edx
   ;	
   ;		}
   ;	  }							  //  ufDigit ϥեȸξ
   ;	
   ;	  int unDigit=anDigit+shift ; //եȤ a( ʤ u )η
   ;	
@15:
@13:
	mov       ecx,dword ptr [ebp-4]
	add       ecx,dword ptr [ebp-24]
	mov       dword ptr [ebp-28],ecx
   ;	
   ;	
   ;	  if( unDigit<bnDigit ) {
   ;	
	mov       eax,dword ptr [ebp-28]
	cmp       eax,dword ptr [ebp-12]
	jge       short @16
   ;	
   ;		this->fDigit=1 ;
   ;	
	mov       edx,dword ptr [ebp+8]
	mov       dword ptr [edx+8],1
   ;	
   ;		return *this=0 ;
   ;	
	push      dword 0
	push      dword ptr [ebp+8]
	call      @Mint@$basg$qxl
	add       esp,8
	jmp       @5
   ;	
   ;	  }
   ;	
   ;					   // bñ٤ʤʲΥ르ꥺŬѤǤʤΤ,
   ;					   // ñѤδؿǽ
   ;	  if( bnDigit==1 ) {
   ;	
@16:
	cmp       dword ptr [ebp-12],1
;	jne       short @18
	je 		@99_18
	jmp		@18
@99_18	
   ;	
   ;		isShiftl(a,long(shift)<<5) ;
   ;	
@17:
	mov       ecx,dword ptr [ebp-24]
	shl       ecx,5
	push      ecx
	push      dword ptr [ebp+12]
	push      dword ptr [ebp+8]
	call      @Mint@isShiftl$qrx4Mintxl
	add       esp,12
   ;	
   ;		fDigit=ufDigit ;
   ;	
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [ebp-20]
	mov       dword ptr [eax+8],edx
   ;	
   ;	
   ;		if( b.isNegative() ) {
   ;	
	mov       ecx,dword ptr [ebp+16]
	cmp       dword ptr [ecx+12],0
	setl      al
	and       eax,1
	test      al,al
	je        short @20
   ;	
   ;		  if( isNegative() ) nDim&=_POSITIVE_ ;	 // ȿž
   ;	
@19:
	mov       edx,dword ptr [ebp+8]
	cmp       dword ptr [edx+12],0
	setl      cl
	and       ecx,1
	test      cl,cl
	je        short @21
	mov       eax,dword ptr [ebp+8]
	and       dword ptr [eax+12],33554431
	jmp       short @22
   ;	
   ;		  else nDim|=_NEGATIVE_ ;
   ;	
@21:
	mov       edx,dword ptr [ebp+8]
	or        dword ptr [edx+12],-16777216
   ;	
   ;		}
   ;						// compute as integer
   ;		return	(Fint&)((Mint*)this)->isDivUL((Mint&)*this,*b.digit) ;
   ;	
@22:
@20:
	mov       ecx,dword ptr [ebp+16]
	mov       eax,dword ptr [ecx]
	push      dword ptr [eax]
	push      dword ptr [ebp+8]
	push      dword ptr [ebp+8]
	call      @Mint@isDivUL$qrx4Mintxul
	add       esp,12
	jmp       @5
   ;	
   ;	  }
   ;	
   ;	  int sft(31) ;
   ;	
@18:
	mov       dword ptr [ebp-32],31
   ;	
   ;	  signed char bSign,qSign ;
   ;	  unsigned long q,res ;
   ;	  unsigned long v1,v2 ;
   ;	
   ;	  int qnDigit=unDigit-bnDigit+1 ;
   ;	
	mov       edx,dword ptr [ebp-28]
   ;	
   ;	  unsigned long j ;
   ;	  unsigned long j_n4 ;
   ;	
   ;	  int Count ;
   ;	  unsigned long ui,vi,ti ;
   ;	  if( _uMtemp.ndim()<=unDigit+1 ) _uMtemp.allocate(unDigit+1) ;
   ;	
	mov       eax,dword ptr [@Mint@_uMtemp+12]
	sub       edx,dword ptr [ebp-12]
	and       eax,16777215
	inc       edx
	mov       dword ptr [ebp-56],edx
	mov       ecx,dword ptr [ebp-28]
	inc       ecx
	cmp       ecx,eax
	jl        short @23
	mov       edx,dword ptr [ebp-28]
	inc       edx
	push      edx
	push      dword offset @Mint@_uMtemp
	call      @Mint@allocate$qi
	add       esp,8
   ;	
   ;	  if( _vMtemp.ndim()< bnDigit )	 _vMtemp.allocate(bnDigit) ;
   ;	
@23:
	mov       ecx,dword ptr [@Mint@_vMtemp+12]
	and       ecx,16777215
	cmp       ecx,dword ptr [ebp-12]
	jge       short @24
	push      dword ptr [ebp-12]
	push      dword offset @Mint@_vMtemp
	call      @Mint@allocate$qi
	add       esp,8
   ;	
   ;	  Count=ufDigit+1 ;
   ;	
@24:
	mov       eax,dword ptr [ebp-20]
	inc       eax
	mov       dword ptr [ebp-68],eax
   ;	
   ;	  Count=Count>qnDigit ? Count:qnDigit ;
   ;	
	mov       edx,dword ptr [ebp-68]
	cmp       edx,dword ptr [ebp-56]
	jle       short @25
	mov       ecx,dword ptr [ebp-68]
	jmp       short @26
@25:
	mov       ecx,dword ptr [ebp-56]
@26:
	mov       dword ptr [ebp-68],ecx
   ;	
   ;	  if( ndim()<Count ) allocate(Count) ;
   ;	
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [eax+12]
	and       edx,16777215
	cmp       edx,dword ptr [ebp-68]
	jge       short @27
	mov       eax,dword ptr [ebp-68]
	mov       dword ptr [ebp-84],eax
	push      dword ptr [ebp-84]
	push      dword ptr [ebp+8]
	call      @Mint@allocate$qi
	add       esp,8
   ;	
   ;								   // 
   ;	#ifndef __BORLANDC__
   ;	  unsigned long* uptr=Mint::_uMtemp.digit;
   ;	  unsigned long* vptr=Mint::_vMtemp.digit ;
   ;	#endif
   ;	
   ;	//D1:
   ;	  __asm {
   ;		mov	  ebx,this
   ;	
@27:
	mov		  ebx,dword ptr [ebp+8]
   ;	
   ;		mov	  eax,ufDigit
   ;	
	mov		  eax,dword ptr [ebp-20]
   ;	
   ;	#ifdef __BORLANDC__
   ;		mov	  [ebx.fDigit],eax
   ;	
	mov		  [ebx+8],eax
   ;	
   ;		mov	  ebx,[ebx]
   ;	
	mov		  ebx,[ebx]
   ;	
   ;		mov	  ti,ebx
   ;	
	mov		  dword ptr [ebp-80],ebx
   ;	
   ;		mov	  esi,dword ptr [@Mint@_vMtemp]
   ;	
	mov		  esi,dword ptr [@Mint@_vMtemp]
   ;	
   ;		mov	  edi,dword ptr [@Mint@_uMtemp]
   ;	
	mov		  edi,dword ptr [@Mint@_uMtemp]
   ;	
   ;	#else
   ;		mov	  [ebx+FDIGIT],eax
   ;		mov	  ebx,[ebx]
   ;		mov	  ti,ebx
   ;		mov	  esi,vptr
   ;		mov	  edi,uptr
   ;	#endif
   ;		mov	  dword ptr ui,edi	 // ٤⥢ɥ쥹ȤľΤ٤ˤʤΤ
   ;	
	mov		  dword ptr dword ptr [ebp-72],edi	 
   ;	
   ;		mov	  dword ptr vi,esi	 // ǥå쥸ФƤ
   ;	
	mov		  dword ptr dword ptr [ebp-76],esi	 
   ;	
   ;	
   ;		mov	  edi,b
   ;	
	mov		  edi,dword ptr [ebp+16]
   ;	
   ;	#ifdef __BORLANDC__
   ;		mov	  al,[edi.nDim+3]
   ;	
	mov		  al,[edi+12+3]
   ;	
   ;		mov	  edi,[edi]
   ;	
	mov		  edi,[edi]
   ;	
   ;	#else
   ;		mov	  al,[edi+SIGN]
   ;		mov	  edi,[edi]
   ;	#endif
   ;		mov	  bSign,al
   ;	
	mov		  byte ptr [ebp-33],al
   ;	
   ;		mov	  ebx,bnDigit		// vͭ
   ;	
	mov		  ebx,dword ptr [ebp-12]		
   ;	
   ;		bsr	  ecx,[ebx*NBYTE+edi-NBYTE]
   ;	
	bsr		  ecx,[ebx*(4)+edi-(4)]
   ;	
   ;		sub	  sft,ecx
   ;	
	sub		  dword ptr [ebp-32],ecx
   ;	
   ;		mov	  ecx,sft
   ;	
	mov		  ecx,dword ptr [ebp-32]
   ;	
   ;	
   ;		mov	  eax,[edi+ebx*NBYTE-NBYTE]
   ;	
	mov		  eax,[edi+ebx*(4)-(4)]
   ;	
   ;		shld  edx,eax,cl
   ;	
	shld	  edx,eax,cl
   ;	
   ;	  }
   ;	mult_vd:						  // _vMtemp=b<<sht
   ;	  __asm {
   ;		dec	  ebx
   ;	
@28:
	dec		  ebx
   ;	
   ;		jz	  EXIT1
   ;	
	je        short @29
   ;	
   ;		mov	  edx,eax
   ;	
	mov		  edx,eax
   ;	
   ;		mov	  eax,[edi+ebx*NBYTE-NBYTE]
   ;	
	mov		  eax,[edi+ebx*(4)-(4)]
   ;	
   ;		shld  edx,eax,cl
   ;	
	shld	  edx,eax,cl
   ;	
   ;		mov	  [esi+ebx*NBYTE],edx
   ;	
	mov		  [esi+ebx*(4)],edx
   ;	
   ;		jmp	  mult_vd
   ;	
	jmp       short @28
   ;	
   ;	  }
   ;	EXIT1:
   ;	  __asm {
   ;		shl	  eax,cl
   ;	
@29:
	shl		  eax,cl
   ;	
   ;		mov	  [esi],eax
   ;	
	mov		  [esi],eax
   ;	
   ;	
   ;		mov	  esi,ui
   ;	
	mov		  esi,dword ptr [ebp-72]
   ;	
   ;		mov	  ebx,shift
   ;	
	mov		  ebx,dword ptr [ebp-24]
   ;	
   ;		or	  ebx,ebx
   ;	
	or		  ebx,ebx
   ;	
   ;		jz	  skip_Clear_u
   ;	
	je        short @30
   ;	
   ;		mov	  edx,ebx
   ;	
	mov		  edx,ebx
   ;	
   ;		xor	  eax,eax
   ;	
	xor		  eax,eax
   ;	
   ;	  }
   ;	Clear_u:				 // shift ʬ η
   ;	  __asm {
   ;		mov	  [ebx*NBYTE+esi-NBYTE],eax
   ;	
@31:
	mov		  [ebx*(4)+esi-(4)],eax
   ;	
   ;		dec	  ebx
   ;	
	dec		  ebx
   ;	
   ;		jnz	  Clear_u
   ;	
	jne       short @31
   ;	
   ;		lea	  esi,[esi+edx*NBYTE]
   ;	
	lea		  esi,[esi+edx*(4)]
   ;	
   ;	  }
   ;	skip_Clear_u:
   ;	  __asm {
   ;	
   ;		mov	  ebx,anDigit  // a η (ե)
   ;	
@30:
	mov		  ebx,dword ptr [ebp-4]  
   ;	
   ;	
   ;		mov	  edi,a
   ;	
	mov		  edi,dword ptr [ebp+12]
   ;	
   ;	#ifdef __BORLANDC__
   ;		mov	  al,[edi.nDim+3]
   ;	
	mov		  al,[edi+12+3]
   ;	
   ;		mov	  edi,[edi]
   ;	
	mov		  edi,[edi]
   ;	
   ;	#else
   ;		mov	  al,[edi+SIGN]
   ;		mov	  edi,[edi]
   ;	#endif
   ;		imul  bSign
   ;	
	imul	  byte ptr [ebp-33]
   ;	
   ;		mov	  qSign,al
   ;	
	mov		  byte ptr [ebp-34],al
   ;	
   ;	
   ;		xor	  edx,edx
   ;	
	xor		  edx,edx
   ;	
   ;		mov	  eax,[edi+ebx*NBYTE-NBYTE]
   ;	
	mov		  eax,[edi+ebx*(4)-(4)]
   ;	
   ;		shld  edx,eax,cl
   ;	
	shld	  edx,eax,cl
   ;	
   ;		mov	  [esi+ebx*NBYTE],edx
   ;	
	mov		  [esi+ebx*(4)],edx
   ;	
   ;	  }
   ;	mult_ud:						  // r=u<<cl
   ;	  __asm {
   ;		dec	  ebx
   ;	
@32:
	dec		  ebx
   ;	
   ;		jz	  EXIT2
   ;	
	je        short @33
   ;	
   ;		mov	  edx,eax
   ;	
	mov		  edx,eax
   ;	
   ;		mov	  eax,[edi+ebx*NBYTE-NBYTE]
   ;	
	mov		  eax,[edi+ebx*(4)-(4)]
   ;	
   ;		shld  edx,eax,cl
   ;	
	shld	  edx,eax,cl
   ;	
   ;		mov	  [esi+ebx*NBYTE],edx
   ;	
	mov		  [esi+ebx*(4)],edx
   ;	
   ;		jmp	  mult_ud
   ;	
	jmp       short @32
   ;	
   ;	  }
   ;	EXIT2:
   ;	  __asm {
   ;		shl	  eax,cl
   ;	
@33:
	shl		  eax,cl
   ;	
   ;		mov	  [esi],eax
   ;	
	mov		  [esi],eax
   ;	
   ;	  }
   ;	//D2:
   ;	  __asm {					// 
   ;		mov	  ebx,bnDigit
   ;	
	mov		  ebx,dword ptr [ebp-12]
   ;	
   ;		mov	  edi,vi			// v  ǥå
   ;	
	mov		  edi,dword ptr [ebp-76]			
   ;	
   ;		mov	  eax,[ebx*NBYTE+edi-NBYTE]
   ;	
	mov		  eax,[ebx*(4)+edi-(4)]
   ;	
   ;		mov	  v1,eax			// vκǾ̷
   ;	
	mov		  dword ptr [ebp-48],eax			
   ;	
   ;		mov	  eax,[ebx*NBYTE+edi-2*NBYTE]
   ;	
	mov		  eax,[ebx*(4)+edi-2*(4)]
   ;	
   ;		mov	  v2,eax			// vμη
   ;	
	mov		  dword ptr [ebp-52],eax			
   ;	
   ;	
   ;		mov	  eax,unDigit		// uη
   ;	
	mov		  eax,dword ptr [ebp-28]		
   ;	
   ;		mov	  j,eax				// j ϥ
   ;	
	mov		  dword ptr [ebp-60],eax				
   ;	
   ;		sub	  eax,bnDigit
   ;	
	sub		  eax,dword ptr [ebp-12]
   ;	
   ;		shl	  eax,2
   ;	
	shl		  eax,2
   ;	
   ;		mov	  j_n4,eax
   ;	
	mov		  dword ptr [ebp-64],eax
   ;	
   ;	
   ;		add	  ti,eax
   ;	
	add		  dword ptr [ebp-80],eax
   ;	
   ;	  }
   ;	
   ;	D3:							   // 
   ;	  __asm {
   ;		mov	  ebx,j
   ;	
@34:
	mov		  ebx,dword ptr [ebp-60]
   ;	
   ;		mov	  esi,ui
   ;	
	mov		  esi,dword ptr [ebp-72]
   ;	
   ;		mov	  edx,[ebx*NBYTE+esi]	// dx=u[j]
   ;	
	mov		  edx,[ebx*(4)+esi]	
   ;	
   ;		cmp	  edx,v1
   ;	
	cmp		  edx,dword ptr [ebp-48]
   ;	
   ;		jne	  not_equal
   ;	
	jne       short @35
   ;	
   ;		mov	  eax,0ffffffffh		  // u[j]==v1
   ;	
	mov		  eax,0ffffffffh		  
   ;	
   ;		mov	  q,eax
   ;	
	mov		  dword ptr [ebp-40],eax
   ;	
   ;		mov	  ecx,[ebx*NBYTE+esi-NBYTE]
   ;	
	mov		  ecx,[ebx*(4)+esi-(4)]
   ;	
   ;	  }
   ;	test0:
   ;	  __asm {
   ;		add	  ecx,v1
   ;	
@36:
	add		  ecx,dword ptr [ebp-48]
   ;	
   ;		jc	  D4
   ;	
	jb        @37
   ;	
   ;		mov	  res,ecx
   ;	
	mov		  dword ptr [ebp-44],ecx
   ;	
   ;		jmp	  test1
   ;	
	jmp       short @38
   ;	
   ;	  }
   ;	not_equal:
   ;	  __asm {
   ;		mov	  eax,[ebx*NBYTE+esi-NBYTE]
   ;	
@35:
	mov		  eax,[ebx*(4)+esi-(4)]
   ;	
   ;		div	  v1
   ;	
	div		  dword ptr [ebp-48]
   ;	
   ;		mov	  q,eax		// q=
   ;	
	mov		  dword ptr [ebp-40],eax		
   ;	
   ;		mov	  res,edx	// res=;
   ;	
	mov		  dword ptr [ebp-44],edx	
   ;	
   ;	  }
   ;	test1:
   ;	  __asm {
   ;		mov	  eax,v2
   ;	
@38:
	mov		  eax,dword ptr [ebp-52]
   ;	
   ;		mul	  q
   ;	
	mul		  dword ptr [ebp-40]
   ;	
   ;		mov	  ecx,[ebx*NBYTE+esi-2*NBYTE]
   ;	
	mov		  ecx,[ebx*(4)+esi-2*(4)]
   ;	
   ;		sub	  ecx,eax
   ;	
	sub		  ecx,eax
   ;	
   ;		mov	  ecx,res
   ;	
	mov		  ecx,dword ptr [ebp-44]
   ;	
   ;		sbb	  ecx,edx
   ;	
	sbb		  ecx,edx
   ;	
   ;		jnc	  D4
   ;	
	jae       short @37
   ;	
   ;	  }
   ;	//q_1:
   ;	  __asm {			 // 礭᤮
   ;		dec	  q			 //  1 餹
   ;	
	dec		  dword ptr [ebp-40]			 
   ;	
   ;		jmp	  test0
   ;	
	jmp       @36
   ;	
   ;	  }
   ;	D4:
   ;	  __asm {					// u-=q*v ׻
   ;		mov	  edi,vi
   ;	
@37:
	mov		  edi,dword ptr [ebp-76]
   ;	
   ;		mov	  ecx,bnDigit
   ;	
	mov		  ecx,dword ptr [ebp-12]
   ;	
   ;		mov	  esi,ui
   ;	
	mov		  esi,dword ptr [ebp-72]
   ;	
   ;		add	  esi,j_n4
   ;	
	add		  esi,dword ptr [ebp-64]
   ;	
   ;		mov	  Count,ecx
   ;	
	mov		  dword ptr [ebp-68],ecx
   ;	
   ;	
   ;		xor	  ecx,ecx	   // ecx=Overflow
   ;	
	xor		  ecx,ecx	   
   ;	
   ;		mov	  ebx,ecx	   // ebx=carry
   ;	
	mov		  ebx,ecx	   
   ;	
   ;	  }
   ;	mult:
   ;	  __asm {
   ;		mov	  eax,[edi]
   ;	
@39:
	mov		  eax,[edi]
   ;	
   ;		lea	  edi,[edi+NBYTE]
   ;	
	lea		  edi,[edi+(4)]
   ;	
   ;		mul	  q
   ;	
	mul		  dword ptr [ebp-40]
   ;	
   ;		add	  eax,ecx
   ;	
	add		  eax,ecx
   ;	
   ;		adc	  edx,0
   ;	
	adc		  edx,0
   ;	
   ;		mov	  ecx,edx		// 夢դ򥻡
   ;	
	mov		  ecx,edx		
   ;	
   ;	  }
   ;	//next1:
   ;	  __asm {
   ;		add	  eax,ebx
   ;	
	add		  eax,ebx
   ;	
   ;		adc	  ecx,0
   ;	
	adc		  ecx,0
   ;	
   ;		sbb	  [esi],eax
   ;	
	sbb		  [esi],eax
   ;	
   ;		mov	  ebx,0
   ;	
	mov		  ebx,0
   ;	
   ;	//	  adc	ebx,0
   ;		adc	  ebx,ebx
   ;	
	adc		  ebx,ebx
   ;	
   ;		lea	  esi,[esi+NBYTE]
   ;	
	lea		  esi,[esi+(4)]
   ;	
   ;		dec	  Count
   ;	
	dec		  dword ptr [ebp-68]
   ;	
   ;		jnz	  mult
   ;	
	jne       @39
   ;	
   ;		mov	  eax,ecx
   ;	
	mov		  eax,ecx
   ;	
   ;		mov	  ecx,0
   ;	
	mov		  ecx,0
   ;	
   ;		add	  eax,ebx
   ;	
	add		  eax,ebx
   ;	
   ;		adc	  ecx,0
   ;	
	adc		  ecx,0
   ;	
   ;		sbb	  [esi],eax
   ;	
	sbb		  [esi],eax
   ;	
   ;		adc	  ecx,0
   ;	
	adc		  ecx,0
   ;	
   ;	  }
   ;	//D5:
   ;	  __asm {
   ;		mov	  edi,ti
   ;	
	mov		  edi,dword ptr [ebp-80]
   ;	
   ;		mov	  eax,q
   ;	
	mov		  eax,dword ptr [ebp-40]
   ;	
   ;		mov	  [edi],eax
   ;	
	mov		  [edi],eax
   ;	
   ;		jecxz D7
   ;	
	jecxz     @40
   ;	
   ;	  }
   ;	//D6:
   ;	  __asm {			  // ᤮Τǲä᤹
   ;		dec	  dword ptr [edi]
   ;	
	dec		  dword ptr [edi]
   ;	
   ;		mov	  ecx,bnDigit
   ;	
	mov		  ecx,dword ptr [ebp-12]
   ;	
   ;		mov	  edi,vi
   ;	
	mov		  edi,dword ptr [ebp-76]
   ;	
   ;		mov	  esi,ui
   ;	
	mov		  esi,dword ptr [ebp-72]
   ;	
   ;		add	  esi,j_n4
   ;	
	add		  esi,dword ptr [ebp-64]
   ;	
   ;	
   ;		xor	  ebx,ebx
   ;	
	xor		  ebx,ebx
   ;	
   ;	  }
   ;	LOOP_3:
   ;	  __asm {
   ;		mov	  eax,[ebx*NBYTE+edi]
   ;	
@41:
	mov		  eax,[ebx*(4)+edi]
   ;	
   ;		adc	  [ebx*NBYTE+esi],eax
   ;	
	adc		  [ebx*(4)+esi],eax
   ;	
   ;		inc	  ebx
   ;	
	inc		  ebx
   ;	
   ;		dec	  ecx
   ;	
	dec		  ecx
   ;	
   ;		jnz	  LOOP_3
   ;	
	jne       short @41
   ;	
   ;		adc	  dword ptr [ebx*NBYTE+esi],0
   ;	
	adc		  dword ptr [ebx*(4)+esi],0
   ;	
   ;	  }
   ;	D7:
   ;	  __asm {
   ;		cmp	  j_n4,0
   ;	
@40:
	cmp		  dword ptr [ebp-64],0
   ;	
   ;		jle	  D8
   ;	
	jle       short @42
   ;	
   ;		sub	  j_n4,NBYTE
   ;	
	sub		  dword ptr [ebp-64],(4)
   ;	
   ;		dec	  j
   ;	
	dec		  dword ptr [ebp-60]
   ;	
   ;		sub	  ti,NBYTE
   ;	
	sub		  dword ptr [ebp-80],(4)
   ;	
   ;		jmp	  D3
   ;	
	jmp       @34
   ;	
   ;	  }
   ;	D8:
   ;	  __asm {
   ;		mov	  edi,this
   ;	
@42:
	mov		  edi,dword ptr [ebp+8]
   ;	
   ;	#ifdef __BORLANDC__
   ;		mov	  esi,[edi]
   ;	
	mov		  esi,[edi]
   ;	
   ;	#else
   ;		mov	  esi,[edi]
   ;	#endif
   ;	
   ;		mov	  ebx,qnDigit		// κͭ
   ;	
	mov		  ebx,dword ptr [ebp-56]		
   ;	
   ;	
   ;		mov	  cl,qSign
   ;	
	mov		  cl,byte ptr [ebp-34]
   ;	
   ;		xor	  eax,eax
   ;	
	xor		  eax,eax
   ;	
   ;	  }
   ;	Search_nonZero:
   ;	  __asm {
   ;		cmp	  [ebx*NBYTE+esi-NBYTE],eax
   ;	
@43:
	cmp		  [ebx*(4)+esi-(4)],eax
   ;	
   ;		jne	  nonZero
   ;	
	jne       short @44
   ;	
   ;		dec	  ebx
   ;	
	dec		  ebx
   ;	
   ;		jnz	  Search_nonZero
   ;	
	jne       short @43
   ;	
   ;		mov	  cl,1		// ٤Ƥη夬 1 ˤ
   ;	
	mov		  cl,1		
   ;	
   ;	  }
   ;	nonZero:
   ;	  __asm{
   ;	#ifdef __BORLANDC__
   ;		mov	  [edi.nDigit],ebx
   ;	
@44:
	mov		  [edi+4],ebx
   ;	
   ;		mov	  [edi.nDim+3],cl
   ;	
	mov		  [edi+12+3],cl
   ;	
   ;	#else
   ;		mov	  [edi+NDIGIT],ebx
   ;		mov	  [edi+SIGN],cl
   ;	#endif
   ;	  }
   ;	
   ;	#ifdef _MEMMAN_DEBUG
   ;	this->check(__FILE__,__LINE__) ;
   ;	#endif
   ;	
   ;	  return *this ;
   ;	
	mov       eax,dword ptr [ebp+8]
   ;	
   ;	
   ;	}
   ;	
@45:
@5:
	pop       edi
	pop       esi
	pop       ebx
	mov       esp,ebp
	pop       ebp
	ret 
[SECTION .data]
s@
	;	s@+0:
	db	"Error occured : %s, file %s, line %d",10,0
	;	s@+38:
	db	"zero divide",0
	;	s@+50:
	db	"..\source\lib\divf.cpp",0
