//
//  Copyright (C) by S.Tomabechi 1997
//  All rights reserved.
//
//  return primoiral p#=\rpod q
//                      q:prime q<=p
//
#include "Mint.hpp"

Mint primorial(const unsigned long p)
{
  unsigned long q(1) ;
  Mint ps(1) ;
                    
  for(;;) {
    q=nextprm(q) ;
    if( q<=p ) ps*=q ;
    else break ;
  }
  return ps ;
}
