//
//  Copyright (C) by S.Tomabechi 1993-1996
//  All rights reserved.
//
//  substract integers
//
//  ̑dx̍
//  this==&a 邢 this==&b ł悢
//  this==&b ̏ꍇ́Ab Rs[邽߂̕x
//
#ifdef __BORLANDC__
#pragma inline
#endif

#ifndef __cplusplus
#error Must use C++ for the type Mint
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "Error.hpp"

Mint& Mint::isSub(const Mint& a,const Mint& b)
{
#ifdef _MEMMAN_DEBUG
a.check(__FILE__,__LINE__) ;
b.check(__FILE__,__LINE__) ;
#endif
  __asm {
    mov esi,a
    mov edi,b
#ifdef __BORLANDC__
    mov bl,[edi.nDim+3]
    cmp [esi.nDim+3],bl
#else
    mov bl,[edi+SIGN]
    cmp [esi+SIGN],bl
#endif
    je  SAME
                                        // ٕ̏ꍇ
#ifdef __BORLANDC__
    neg byte ptr [edi.nDim+3]          // 𔽓]
#else
    neg byte ptr [edi+SIGN]
#endif
  }

  isAdd(a,b) ;                          // łȂa߂

#ifdef _MEMMAN_DEBUG
_MemMan.check(__FILE__,__LINE__) ;
#endif

  __asm {                               // Ƃɖ߂
    mov edi,b
    cmp edi,this
    je  RET1

#ifdef __BORLANDC__
    neg byte ptr [edi.nDim+3]
#else
    neg byte ptr [edi+SIGN]
#endif
    jmp RET1
  }

SAME:

  int shift ;
  int anDigit ;
  int bnDigit ;
  int _sign(1) ;
  bool same ;
  __asm {
#ifdef __BORLANDC__
    mov  eax,[esi.fDigit]
    sub  eax,[edi.fDigit]
#else
    mov  eax,[esi+FDIGIT]
    sub  eax,[edi+FDIGIT]
#endif
    mov  shift,eax          // shift>a.fdigit ?
//    cmp  eax,0
    or   eax,eax
    jge  NOT_EXCHANGE
  }

                           // ċAȂ悤ɂ 1995.07.15
  __asm {                  // a  b 
    xchg  a,edi
    xchg  b,esi
    neg shift
    neg _sign
  }

NOT_EXCHANGE:
  __asm {
#ifdef __BORLANDC__
    mov  eax,[esi.nDigit]
    mov  ebx,[edi.nDigit]
#else
    mov  eax,[esi+NDIGIT]
    mov  ebx,[edi+NDIGIT]
#endif

    mov  anDigit,eax
    add  ebx,shift
    mov  bnDigit,ebx
    cmp  esi,this
    sete same
  }

  int max_a_b=anDigit>bnDigit ? anDigit:bnDigit ;
  int min_a_b=anDigit<bnDigit ? anDigit:bnDigit ;
  if( min_a_b<shift ) min_a_b=shift ;
  int max_min=max_a_b-min_a_b ;
  bool Carry(false) ;
  unsigned long* v ;

  if( this==&b ) {
    (_vMtemp=b).fDigit=0 ;
    v=_vMtemp.digit ;
  }
  else v=b.digit ;

       // 傫̌ɍ킹
  if( ndim()<max_a_b ) {
    if( same ) reallocate(max_a_b) ;
    else allocate(max_a_b) ;
  }

  __asm {

    mov   edi,this
    mov   esi,a
#ifdef __BORLANDC__
    mov   eax,max_a_b
    mov   [edi.nDigit],eax
    mov   eax,[esi.fDigit]
    mov   [edi.fDigit],eax
    mov   al,[esi.nDim+3]
    mov   [edi.nDim+3],al

    mov   edi,[edi]     // di=offset of digit
    mov   esi,[esi]     // si=offset of a.digit
#else
    mov   eax,max_a_b
    mov   [edi+NDIGIT],eax
    mov   eax,[esi+FDIGIT]
    mov   [edi+FDIGIT],eax
    mov   al,[esi+SIGN]
    mov   [edi+SIGN],al

    mov   edi,[edi+DIGIT]
    mov   esi,[esi+DIGIT]
#endif
    mov   ecx,shift
    jecxz pre_Loop1
    cmp   same,0              // ߂lƓ
    jne   SetZero             // ̔r͂ȂĂ悢
    cmp   ecx,anDigit
    jbe   Copy
    mov   ecx,anDigit
    dec   ecx
    js    SetZero
//    jecxz SetZero
  }
Copy:                         // Ɋ֗^ȂRs[
  __asm {
    mov   eax,[ecx*NBYTE+esi]
    mov   [ecx*NBYTE+edi],eax
    dec   ecx
    jns   Copy
  }
SetZero:                      // a ̌傫NA[
  __asm {
    mov   ecx,shift
    mov   edx,anDigit
    sub   ecx,edx
    jbe  pre_Loop1
  }
More:
  __asm {
    mov   dword ptr [edx*NBYTE+edi],0
    inc   edx
    dec   ecx
    jnz   More
  }
pre_Loop1:                    // a  b ̃I[obv镔̍߂
  __asm {
    mov   ebx,v               // address of b.digit

    mov   eax,shift           // _ʒu𑵂
    lea   edi,[edi+eax*NBYTE]
    lea   esi,[esi+eax*NBYTE]
    xor   edx,edx             // edx=0 ɂƂƂɂӂ
                              // edx  index ƂĎgp
    mov   ecx,min_a_b
    sub   ecx,shift
    jng   skip1               // a.nDigit<b.nDigit+shift ?
    cmp   same,1              // this=&a ł. ʏ
    je    subself
    clc                       // Carray flag off
  }
loop1:
  __asm {
    mov   eax,[edx*NBYTE+esi]  // a.digit[j+shift]
    sbb   eax,[edx*NBYTE+ebx]  // eax=a.digit[j+shift]-b.digit[j]
    mov   [edx*NBYTE+edi],eax  // digit[j+shift]=eax
    inc   edx
    dec   ecx
    jnz   loop1
    setc  Carry                 // carry flag ۑ
    jmp   skip1
  }
subself:
  __asm {
    mov   esi,ebx
    xor   edx,edx
  }
loop11:                       // digit[j+shift]=digit[j+shift]-b.digit[j]
  __asm {                       // ߂l a 
    mov   eax,[edx*NBYTE+esi]
    sbb   [edx*NBYTE+edi],eax
    inc   edx
    dec   ecx
    jnz   loop11
    setc  Carry              // carry falg ۑ
    mov   esi,edi
  }
skip1:
  __asm {
    mov   ecx,anDigit         // c̏
    cmp   ecx,bnDigit
    jg    a_is_great          // a ̌̕傫
    mov   esi,ebx
  }
//set_flag:
  __asm {
    xor   al,al
    cmp   al,Carry
  }
//b_is_great:                   // b ̌̕傫
  __asm {
    mov    ecx,max_min
    jecxz  Overflow           // č͂Ȃ
  }

loop21:
  __asm {                     // č
    mov   eax,0               // Ή a ̌ 0 ƌ
    sbb   eax,[edx*NBYTE+esi]
    mov   [edx*NBYTE+edi],eax        // ʂ߂lɃZ[u
    inc   edx
    dec   ecx
    jnz   loop21
    jmp   Overflow
  }
a_is_great:                   // a ̕č
  __asm {
    xor   al,al
    cmp   al,Carry            // Z[uĂ carry flag 𕜊
    mov   ecx,max_min
    jecxz Overflow            // č͂Ȃ
  }
loop2:
  __asm {                     // č
    mov   eax,[edx*NBYTE+esi]
    sbb   eax,0               // Ή b ̌ 0 ƂAborrow ň
    mov   [edx*NBYTE+edi],eax
    inc   edx
    dec   ecx
    jnz   loop2
  }
Overflow:
  __asm {
    jnc   end                 // b ̕傫 ?

    mov   esi,this
#ifdef __BORLANDC__
    neg   byte ptr [esi.nDim+3]
    mov   esi,[esi]
#else
    neg   byte ptr [esi+SIGN]
    mov   esi,[esi+DIGIT]
#endif
    mov   ecx,max_a_b
    mov   ebx,1

    xor   edx,edx
  }
NEG_LOOP:                     // b ̕傫̂ŁA␔Ƃ
  __asm {                     // lɂ
    mov   eax,[edx*NBYTE+esi]
    not   eax
    adc   eax,ebx
    mov   ebx,0
    adc   ebx,0
    mov   [edx*NBYTE+esi],eax
    inc   edx
    dec   ecx
    jnz   NEG_LOOP
  }
end:
  __asm {
#ifdef __BORLANDC__
    mov   edi,this
    mov   esi,[edi]
    cmp   _sign,0
    jg    not_reverse
    neg   byte ptr [edi.nDim+3]
#else
    mov   edi,this
    mov   esi,[edi+DIGIT]
    cmp   _sign,0
    jg    not_reverse
    neg   byte ptr [edi+SIGN]
#endif
  }
not_reverse:
  __asm {
    mov   ecx,max_a_b
    jecxz SET_ZERO
  }
NORMALIZE:                    // LZbg
  __asm {
    cmp   dword ptr [ecx*NBYTE+esi-NBYTE],0   // 0 ?
    jne   SET_DIGIT           // 0 łȂŏʌ
    dec   ecx
    jnz   NORMALIZE
  }
SET_ZERO:
  __asm {
#ifdef __BORLANDC__
    mov  byte ptr [edi.nDim+3],1
#else
    mov byte ptr [edi+SIGN],1
#endif
  }
SET_DIGIT:
  __asm {
#ifdef __BORLANDC__
    mov [edi.nDigit],ecx   // ecx ͗L
#else
    mov [edi+NDIGIT],ecx
#endif
  }
RET1:
#ifdef _MEMMAN_DEBUG
//_MemMan.check(__FILE__,__LINE__) ;
check(__FILE__,__LINE__) ;
#endif
  return *this ;
}

