//
//  Copyright (C) by S.Tomabechi 1995
//  All rights reserved.
//
//  created at 1995.06.08
//
//  class Mint ͤ 2ʿȤƤߤ뤿Υ饹
//
//  class Mint ޤϥ󥹥ȥ饯 MBit(Mint&) Ѥ
//  󥹥󥹤ȡΥ󥹥󥹤 ˻Ȥ줿 Mint
//  뤤ϥ󥹥ȥ饯Ϥ줿 Mint  alias Ȥʤ롥
//  ä MBit ѹä ꥸʥ Mint ѹ롥
//

#ifndef __MBIT_HPP
#define __MBIT_HPP

#include "Bit.hpp"
#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include <iostream.h>

class MBit
{
  friend class Mint ;
private:
//public:
  Mint* pM ;
  bool isAlias ;                 // Mint  alias ɤ
  static MBit _MBtemp ;
  MBit(const MBit& b) ;          // Υԡ󥹥ȥ饯
                                 // private Τۤ褤
  void SetBitString(const Mint& n) ;
 public:
  MBit() ;
  MBit(const Mint& n) ;
  ~MBit() ;
  bool operator[](const long index) const ;  // index ܤΥӥåȤ֤
  long BitScanForward(void) const ;
  long BitScanReverse(void) const ;
  MBit& operator=(const Mint& n) ;
  MBit& operator=(const MBit& b) ;
  MBit& operator&=(const MBit& b) ;
  MBit& operator|=(const MBit& b) ;
  MBit& operator^=(const MBit& b) ;
  MBit operator&(const MBit& b) const ;
  MBit operator|(const MBit& b) const ;
  MBit operator^(const MBit& b) const ;
  friend int Val2(const Mint& c) ;
  friend ostream& operator<<(ostream& os,const MBit& b) ;
} ;


inline MBit::~MBit()
{
  if( !isAlias ) delete pM ;
}

inline MBit::MBit()
{
  isAlias=false ;
  pM=new Mint ;
}

inline MBit::MBit(const Mint& n)
{
  isAlias=true ;
  pM=(Mint*)&n ;
}

inline MBit::MBit(const MBit& b)
{
  isAlias=false ;
  pM=new Mint ;
  *pM=*b.pM ;
}

inline MBit& MBit::operator&=(const MBit& b)
{
  pM->isAND(*pM,*b.pM) ;
  return *this ;
}

inline MBit& MBit::operator|=(const MBit& b)
{
  pM->isOR(*pM,*b.pM) ;
  return *this ;
}

inline MBit& MBit::operator^=(const MBit& b)
{
  pM->isXOR(*pM,*b.pM) ;
  return *this ;
}

inline MBit& MBit::operator=(const MBit& b)
{
  pM->operator=(*b.pM) ;
  return *this ;
}

inline MBit& MBit::operator=(const Mint& n)
{
  SetBitString(n) ;
  return *this ;
}

inline void MBit::SetBitString(const Mint& n)
{
  if( !isAlias ) delete pM ;
  pM=(Mint*)&n ;
  isAlias=true ;
}

inline bool MBit::operator[](const long index) const
{
  return ::BitIndex(pM->digit,index) ;
}

inline long MBit::BitScanForward(void) const
{
  return ::BitScanForward(pM->digit,long(pM->nDigit)) ;
}

inline long MBit::BitScanReverse(void) const
{
  return ::BitScanReverse(pM->digit,long(pM->nDigit)) ;
}

inline MBit MBit::operator&(const MBit& b) const
{
  Mint::_Mtemp.isAND(*pM,*b.pM) ;
  return _MBtemp ;
}

inline MBit MBit::operator|(const MBit& b) const
{
  Mint::_Mtemp.isOR(*pM,*b.pM) ;
  return _MBtemp ;
}

inline MBit MBit::operator^(const MBit& b) const
{
  Mint::_Mtemp.isXOR(*pM,*b.pM) ;
  return _MBtemp ;
}


#endif

