//
//  Copyright (C) by S.Tomabechi 1994,1995
//  All rights reserved.
//
//  greatest common divisor
//
//
#ifdef __BORLANDC__
#pragma inline
#endif
#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "IntFuncs.hpp"

Mint& Mint::isAGCD(const Mint& u,const Mint& v)
{
  unsigned long w ;
  _uuMtemp=u ;
  _vvMtemp=v ;
  for(;;) {
    if( _vvMtemp.nDigit<=1 ) {    // ꌅ܂͗
      w=(unsigned long)_vvMtemp ;
      if( w==0 ) {
        if( _uuMtemp.isNegative() ) {
#ifdef __BORLANDC__
          __asm mov byte ptr [@Mint@_uuMtemp.nDim+3],1
#else
          _uuMtemp.nDim&=_POSITIVE_ ;
#endif
        }
        *this=_uuMtemp ;
      }
      else *this=gcd(_uuMtemp.isRemUL(w),w) ;
#ifdef _MEMMAN
check(__FILE__,__LINE__) ;
#endif
      return *this ;
    }
    _uuMtemp.isRem(_uuMtemp,_vvMtemp,AbsoluteRem) ;
    if( _uuMtemp.nDigit<=1 ) {
      w=(unsigned long)_uuMtemp ;
      if(  w==0 ) {
        if( _vvMtemp.isNegative() ) {
#ifdef __BORLANDC__
          __asm mov byte ptr [@Mint@_vvMtemp.nDim+3],1
#else
          _vvMtemp.nDim&=_POSITIVE_ ;
#endif
        }
        *this=_vvMtemp ;
      }
      else *this=gcd(_vvMtemp.isRemUL(w),w) ;
#ifdef _MEMMAN
check(__FILE__,__LINE__) ;
#endif
      return *this ;
    }
    _vvMtemp.isRem(_vvMtemp,_uuMtemp,AbsoluteRem) ;
  }
}

