#include "PolyL.hpp"
#include <math.h>
//#include "power.hpp"

// pseudo division Algorithm 3.1.2
//  Ĥϡɬ UFD ǤʤƤ褤.
//
//  d*a=q*b+r
void divide(const PolyL& a,const PolyL& b,
            PolyL& q,PolyL& r,
            long& d)
{

  int j,e ;
  long coeff ;
  int degree;

  r=a ;
  q.allocate((deg(a)-deg(b)>0 ? (deg(a)-deg(b)):0)) ;
//  for( j=0 ; j<q.ndim() ; j++ ) q[j]=0 ;
  q[0]=0 ;
  deg(q)=0 ;
  e=deg(a)-deg(b)+1 ;
  d=b[deg(b)] ;

  for(;;) {
    if( r.isZero() || deg(b)>deg(r) ) {
      long de ;

      de=pow(d,e) ;
      q *= de ;
      r *= de ;
      d=pow(d,deg(a)-deg(b)+1) ;
      return ;
    }
    degree=deg(r)-deg(b) ;
    coeff=r[deg(r)] ;
    q *= d ;
    q[degree]=coeff ;
    deg(q)=(degree>deg(q) ? degree:deg(q)) ;
    j=deg(r) ;
    r *= d ;
    r -= ((b*coeff)<<=degree) ;
    r[j]=0 ;
    j=deg(r)<(j-1) ? deg(r):(j-1) ;
    deg(r)=r>0 ? j:deg(r) ;
//    deg(r)=max(0,min(deg(r),j-1)) ;
    e--  ;
  }


}

