//
//  Copyright (C) by S.Tomabechi 1993
//  All rights reserved.
//
//  calculate power x^n
//
#include "Mint.hpp"

Mint power(const Mint& x,unsigned long n)
{
  Mint::_uuMtemp=x ;
  Mint y(1) ;
  if( n ) for(;;) {
    if( n&1 ) y*=Mint::_uuMtemp ;          // n is odd
    if( (n>>=1)==0 ) break ;
    Mint::_uuMtemp.isSquare(Mint::_uuMtemp) ;  // x *= x
  }
  return y ;
}

#if 0
Mint power(Mint x,Mint n)
{
  Mint y(1) ;
  long leng=ilog2(n) ;

  if( leng>=0 ) for(;;) {
    if( (unsigned long)n&1 ) y *= x ;
    if( --leng<0 ) break ;
    n /= 2 ;
    x *= x ;
  }
  return y ;
}
#endif
