//
//	Copyright (C) by S.Tomabechi 1993-1997
//	ALl rights reserved.
//
//	global constants and work variables
//
#define _ONLY_MINTDECL_

#include "Mint.hpp"
#ifdef _MEMMAN
#  include "MemMan.hpp"
   MemMan Mint::_MemMan ;  // heap memory manager for debug
#endif
#include "FFT.hpp"

Format Mint::format=noFormat ;

int Mint::Precision=2 ;  // default precision
int Mint::Karatsuba_digit=_KARATSUBA_DIGIT_  ;
int Mint::Square_digit=_SQUARE_DIGIT_ ;
int Mint::Toom3_digit=_TOOM3_DIGIT_ ;
int Mint::FFT_digit=_FFT_DIGIT_  ;
//short Mint::Size=4 ; // zmۂƂ̍ŒTCYD
int Mint::Size=1 ;	   // 炩ߕKvȃTCYςƂɂ́A
					   // ̃TCYw肵ĂΗ̈̎撼A
					   // LƎvA܂ʂ͂ȂȋCD
					   // Ƃ肠cD
					   // ݂͖gp.

Mint Mint::_Mtemp ;    // Ɨ̈
Mint Mint::_uuMtemp ;
Mint Mint::_vvMtemp ;
Mint Mint::_uMtemp ;   // ̕ϐ́Aclass Mint  class Fint̓
Mint Mint::_vMtemp ;   // ōƗ̈ƂĎgpĂ邪Aʂ̊֐ł
					   // pȂ悢D̕ϐ̎gm
					   // ŗpꍇłA̕ϐ𗘗pԂ
					   // ȂׂZ悢DpƁAꂩ
					   // ̊֐(Zq)A㏑Ă܂낤D́A
					   // TɂsȃoOA䂫NmȂ.

					   // Fast Fourier Transformation class
FFT Mint::_fft[NUM_OF_FFT_SCHEME] ;
unsigned long Mint::_res ; // PxŏZsۂ̏]
						// Z̒ɂ̂ݎQƉ. ł܂MpĂ͂ȂȂ
							// ]̒l  (2/p)=_Kr_tab[p mod 8]
extern const long _Kr_tab[]={0,1,0,-1,0,-1,0,1} ;

#include "MBit.hpp"
MBit MBit::_MBtemp(Mint::_Mtemp) ;	 // Mint::_Mtemp rbgƂ݂Ȃ
