//
//  Copyright (C) by S.Tomabechi 1994,1996,1997
//  All rights reserved.
//
//  Mint PxŊA̗]Ԃ.
//  ͍lA폜ΒlƂĂ̏]Ԃ.
//  gpۂɂ́ÂƂɂꂮӂ邱.
//  ݁Ao͗pɎgp
//
#ifdef __BORLANDC__
#pragma inline
#endif

#ifndef __cplusplus
#error Must use C++ for the type Mint
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "Error.hpp"

unsigned long Mint::isRemUL(const unsigned long n,int RemType) const
{
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
#endif

  if( n==0 ) Error(zero divide) ;

#ifndef __BORLANDC__
  unsigned long* resptr=&Mint::_res ;
#endif
  __asm {

    mov   edi,this
#ifdef __BORLANDC__
    mov   ecx,[edi.nDigit]    // 
    mov   esi,[edi]
#else
    mov   ecx,[edi+NDIGIT]
    mov   esi,[edi+DIGIT]
#endif
	mov   ebx,n

    xor   edx,edx
//    jecxz Set                           // *this=0
	dec   ecx
	js    short Set
  }
divide1:
  __asm {                               // ŏʂ̌珇Ɋ
//    mov   eax,dword ptr [ecx*NBYTE+esi-NBYTE]
//    div   n
//    dec   ecx
//    jnz   divide1
    mov   eax,[ecx*NBYTE+esi]
    div   ebx
    dec   ecx
    jns   divide1
  }
  __asm {
    cmp   RemType,SameSignRem           // ̏]?
    je    Set
#ifdef __BORLANDC__                     // ŏ]̌vZ
    cmp   dword ptr [edi.nDim],0
#else
    cmp   dword ptr [edi+NDIM],0
#endif
    jge   Set                           // *this>=0
    or    edx,edx                       // ] 0 ?
    jz    Set
    mov   ecx,ebx
    sub   ecx,edx                       // n-edx ]Ƃ (edx>0)
    mov   edx,ecx
  }
Set:
  __asm {

#ifdef __BORLANDC__
    mov   dword ptr [@Mint@_res],edx    // ]Z[u
#else
    mov   esi,resptr
    mov   [esi],edx
#endif
  }
#ifdef _MEMMAN_DEBUG
//_MemMan.check(__FILE__,__LINE__) ;
check(__FILE__,__LINE__) ;
#endif

  return Mint::_res ;
}

Mint& Mint::operator%=(const unsigned long n)
{
                        // residue is zero
  if( (*digit=isRemUL(n))==0 ) { nDim&=_POSITIVE_ ; nDigit=0 ; }
  else nDigit=1 ;       // nonzero residue
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
#endif
  return *this ;
}

